# Record Class QParameterNamed1N<T>

java.lang.Object
java.lang.Record
com.io7m.quarrel.core.QParameterNamed1N<T>

Type Parameters:
  `T` - The type of values
Record Components:
  `name` - The name
  `nameAlternatives` - The alternative names
  `description` - The parameter description string
  `defaultValue` - The default value
  `type` - The type of values

All Implemented Interfaces:
  `QParameterNamedType<T>`, `QParameterType<T>`

public record QParameterNamed1N<T>(String name, List<String> nameAlternatives, QStringType description, Optional<T> defaultValue, Class<T> type) extends Record implements QParameterNamedType<T>
A named parameter with [1, N] cardinality; at least one value must be present.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `QParameterNamed1N(String name, List<String> nameAlternatives, QStringType description, Optional<T> defaultValue, Class<T> type)`
  A named parameter with [1, N] cardinality; at least one value must be present.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `cardinalityMaximum()`
  `int`
  `cardinalityMinimum()`
  `Optional<T>`
  `defaultValue()`
  Returns the value of the `defaultValue` record component.
  `QStringType`
  `description()`
  Returns the value of the `description` record component.
  `final boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `final int`
  `hashCode()`
  Returns a hash code value for this object.
  `String`
  `name()`
  Returns the value of the `name` record component.
  `List<String>`
  `nameAlternatives()`
  Returns the value of the `nameAlternatives` record component.
  `final String`
  `toString()`
  Returns a string representation of this record class.
  `Class<T>`
  `type()`
  Returns the value of the `type` record component.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### QParameterNamed1N

    public QParameterNamed1N(String name, List<String> nameAlternatives, QStringType description, Optional<T> defaultValue, Class<T> type)
    A named parameter with [1, N] cardinality; at least one value must be present.
    Parameters:
      `name` - The name
      `nameAlternatives` - The alternative names
      `description` - The parameter description string
      `defaultValue` - The default value
      `type` - The type of values

- ## Method Details

  - ### cardinalityMinimum

    public int cardinalityMinimum()
    Specified by:
      `cardinalityMinimum` in interface `QParameterNamedType<T>`
    Returns:
      The minimum cardinality of the parameter (typically 0 or 1)

  - ### cardinalityMaximum

    public int cardinalityMaximum()
    Specified by:
      `cardinalityMaximum` in interface `QParameterNamedType<T>`
    Returns:
      The maximum cardinality of the parameter (typically 1 or MAX_VALUE)

  - ### toString

    public final String toString()
    Returns a string representation of this record class. The representation contains the name of the class, followed by the name and value of each of the record components.
    Specified by:
      `toString` in class `Record`
    Returns:
      a string representation of this object

  - ### hashCode

    public final int hashCode()
    Returns a hash code value for this object. The value is derived from the hash code of each of the record components.
    Specified by:
      `hashCode` in class `Record`
    Returns:
      a hash code value for this object

  - ### equals

    public final boolean equals(Object o)
    Indicates whether some other object is "equal to" this one. The objects are equal if the other object is of the same class and if all the record components are equal. All components in this record class are compared with `Objects::equals(Object,Object)`.
    Specified by:
      `equals` in class `Record`
    Parameters:
      `o` - the object with which to compare
    Returns:
      `true` if this object is the same as the `o` argument; `false` otherwise.

  - ### name

    public String name()
    Returns the value of the `name` record component.
    Specified by:
      `name` in interface `QParameterType<T>`
    Returns:
      the value of the `name` record component

  - ### nameAlternatives

    public List<String> nameAlternatives()
    Returns the value of the `nameAlternatives` record component.
    Specified by:
      `nameAlternatives` in interface `QParameterNamedType<T>`
    Returns:
      the value of the `nameAlternatives` record component

  - ### description

    public QStringType description()
    Returns the value of the `description` record component.
    Specified by:
      `description` in interface `QParameterType<T>`
    Returns:
      the value of the `description` record component

  - ### defaultValue

    public Optional<T> defaultValue()
    Returns the value of the `defaultValue` record component.
    Returns:
      the value of the `defaultValue` record component

  - ### type

    public Class<T> type()
    Returns the value of the `type` record component.
    Specified by:
      `type` in interface `QParameterType<T>`
    Returns:
      the value of the `type` record component